// We experiment with the meaning of pointers for 1D arrays

#include <stdio.h>
#include <stdlib.h>
#include <iostream>
using namespace std;

void allocate_mem(double **a, int n)
{
    *a = new double[n];
}

int main()
{
    // double a[10];
    double *a = new double;     // allocating 8 bytes for a double
    double *a3 = new double[3]; // allocating 24 bytes for 3 doubles
    double a1;
    a1 = 3.14159;
    *a = 3.14159;
    double *b1 = &a1;

    *b1 = 35.;
    cout << "a1= " << a1 << endl; // a1 == 35
    b1 = a3;
    cout << "a1= " << a1 << endl; // a1 == 35

    cout << "b1= " << b1 << endl;
    cout << "*b1= " << *b1 << endl;
    cout << "&(*b1)= " << &(*b1) << endl;
    return 0;

    allocate_mem(&a, 10);
    cout << "first a: " << a << endl;
    a = new double[10];
    cout << "second a: " << a << endl;

    printf("a: %p\n", a);
    cout << "a= " << a << endl;

    printf("&a: %p\n", &a);
    cout << "&a= " << &a << endl;

    printf("&a[0]: %p\n", &a[0]);
    cout << "&a[0]= " << &a[0] << endl;

    printf("sizeof(a) = %lu\n", sizeof(a)); // size is 80 = 10 doubles (a is NOT a pointer)
    cout << "sizeof(a)= " << sizeof(a) << endl;

    printf("sizeof(&a) = %lu\n", sizeof(&a)); // size is 4  (&a is a pointer)
    cout << "sizeof(&a)= " << sizeof(&a) << endl;

    printf("sizeof(&a[0])= %lu\n", sizeof(&a[0])); // size is 4 (pointer)
    cout << "sizeof(&a[0])= " << sizeof(&a[0]) << endl;

    printf("a=%p, address(a) = %p\n", a, &a);
    cout << "a= " << a << ",  address(a)= " << &a << endl;

    printf("address(a[0] = %p\n", &a[0]);
    cout << "address(a[0])= " << &a[0] << endl;

    printf("address(a[1] = %p\n", &a[1]);
    cout << "address(a[1])= " << &a[1] << endl;

    printf("address(a[1]=&a[0]+1 = %p\n", &a[0] + 1);
    cout << "address(a[1])= " << &a[0] + 1 << endl;

    printf("address(a[1]=a+1 = %p\n", a + 1);
    cout << "address(a[1])= " << a + 1 << endl;

    // We note that address(a) = address(a[0])
    //-----------------------------------------------

    double *b = new double[10];
    printf("sizeof(b) = %lu\n", sizeof(b)); // size is 4
    cout << "sizeof(b)= " << sizeof(b) << endl;

    printf("sizeof(b[0]) = %lu\n", sizeof(b[0])); // size is 8  (1st element of array b)
    cout << "sizeof(b[0])= " << sizeof(b[0]) << endl;

    printf("sizeof(&b[0]) = %lu\n", sizeof(&b[0])); // size is 4  (address of 1st element is a pointer)
    cout << "sizeof(&b[0])= " << sizeof(&b[0]) << endl;

    printf("b = %lu, address(b) = %lu\n", (unsigned long)b, (unsigned long)&b);
    cout << "b= " << b << ",  address(b)= " << &b << endl;

    printf("&b[0] = %p\n", &b[0]); // size is 4  (address of 2nd element of array b)
    cout << "&b[0]= " << &b[0] << endl;

    printf("&b[1] = %p\n", &b[1]); // size is 4  (address of 2nd element of array b)
    cout << "&b[1]= " << &b[1] << endl;

    printf("b = %lu, address(b) = %lu\n", (unsigned long)b, (unsigned long)&b);
    cout << "b= " << b << ",  address(b)= " << &b << endl;

    delete[] a3;
    delete a;
    delete[] b; // always delete whatever I allocated with new, preferably in the same method

    // What have we learned?
    // double a[10]; ==>  a = &a = &a[0];  // strange but true
    // double* b = new b [10]; // b != &b, but b = &b[0]
    // So in all cases, the name of an array is the address of the first element!
    //----------------------------------------------------------------------

    exit(0);
}
//---------------------------------------------------------------------/-
